require 'spec_helper'
require 'els_token'
require 'yaml'

describe Tester do
  include Rack::Test::Methods

  before :all do
    # obtain a valid els token
    puts "Please provide a valid user which is contained in the els.yml file"
    username = gets.chomp
    puts "Please enter your password"
    password = STDIN.noecho(&:gets).chomp
    els = YAML.load_file(File.join(File.dirname(__FILE__),'..', 'config','els.yml'))["test"]
    @token = ElsToken.authenticate(username,password,els)
  end

  def app
    Tester
  end

  context 'ELS Not Required' do
    it 'should not return 403' do
      get '/no_auth'
      expect(last_response).to be_ok
    end
  end
  
  context 'ELS Required' do
    
    it 'should return 403 with no els token' do
      get '/auth'
      expect(last_response.status).to eql(403)
    end
    
    it 'should return 200 with els token' do
      get '/auth', nil, 'X-API-Key' => "#{@token}"
      expect(last_response).to be_ok
    end
  end

end